Attribute VB_Name = "Calibration_Board"

Public Function ReadHP34401(ADDRESS_34401 As Integer)
'
'  ieee488 commands to read hp34401
'
    a$ = Space(255)
    Call Send(0, ADDRESS_34401, ":READ?", DABend)
    Call Receive(0, ADDRESS_34401, a$, STOPend)
    If ((ibsta) And (EERR)) <> 0 Then
        MsgBox "IEEE ERROR on write to HP34401 ADDRESS=" + Str(ADDRESS_34401)
    End If
    
    If ((ibsta) And (EERR)) <> 0 Then MsgBox "IEEE error in HP34401!  ERROR NO = " + Str$(iberr)
    ReadHP34401 = EngineeringVal(a$)
End Function
Public Function newReadHP34401(addr%)
        Call Send(BD%, addr%, ":READ?", NLend)  'output data
        If ((ibsta% And EERR)) <> 0 Then
            Call Send(BD%, addr%, "*CLS", NLend)  'CLEAR DEVICE
            Call Send(BD%, addr%, "*RST", NLend)  'RESET DEVICE
            Call pause(0.5)
            Call Send(BD%, addr%, ":READ?", NLend)  're-send READ TO DVM
        End If
    Instring$ = String$(256, 32)
    Call Receive(BD%, addr%, Instring$, STOPend)
    DoEvents
    If ((ibsta% And EERR)) <> 0 Then
        Call Send(BD%, addr%, "*CLS", NLend)  'CLEAR DEVICE
        Call Send(BD%, addr%, "*RST", NLend)  'RESET DEVICE
        Call Send(BD%, addr%, ":READ?", NLend)  'GET DATA FROM DVM
        If ((ibsta% And EERR)) <> 0 Then
            Call pause(0.5)
            Call Send(BD%, addr%, "*CLS", NLend)  'CLEAR DEVICE
            Call Send(BD%, addr%, "*RST", NLend)  'RESET DEVICE
            Call Send(BD%, addr%, ":READ?", NLend)  're-send READ TO DVM
        End If
        Call Receive(BD%, addr%, Instring$, STOPend) 'RE-GET DATA FROM DVM
    End If
    DoEvents
    If ((ibsta% And EERR)) <> 0 Then
            Call Send(BD%, addr%, "*CLS", NLend)  'CLEAR DEVICE
            Call Send(BD%, addr%, "*RST", NLend)  'RESET DEVICE
        MsgBox "IEEE PROBLEM READ34401"
    End If
    DoEvents
newReadHP34401 = EngineeringVal(Instring$)
End Function

Public Sub InitIEEE()
  BD% = 0                              'define initial values
  ErrFlag = 0
  Call SendIFC(BD%)            'clear bus
  If (ibsta% And EERR) Then
    Call gpiberr("SendIFC Error")
    MsgBox "Init IEEE failed"
  Else
    v% = 1
    Call ibsre(BD%, v%)
    If (ibsta% And EERR) Then
      Call gpiberr("SendIFC Error")
      txtGPIBErr.Text = RetMsg$
      txtGPIBErr.Visible = True
    Else
      v% = 12 'WAS 11
      Call ibtmo(BD%, v%)
      If (ibsta% And EERR) Then
        Call gpiberr("SendIFC Error")
        txtGPIBErr.Text = RetMsg$
        txtGPIBErr.Visible = True
      End If
    End If
  End If

End Sub
Public Sub Set_U10_U11_Test_Bits(U10_Bits As Byte, U11_bits As Byte)
'
'  This is for the test (calibration) board only
'  U10 and U11 are 8 bit latches that control FET switches on the test board
'
Call RunMnemonicCommand("CMD CTRL " + Hex(U11_bits))
Call RunMnemonicCommand("I2C CH2 S 7E ACKS 00 ACKM P") 'CLK LOW
Call RunMnemonicCommand("I2C CH2 S 7E ACKS 80 ACKM P") 'CLK HIGH
Call RunMnemonicCommand("I2C CH2 S 7E ACKS 00 ACKM P") 'CLK LOW
Call RunMnemonicCommand("CMD CTRL " + Hex(U10_Bits))
Call RunMnemonicCommand("I2C CH2 S 7E ACKS 00 ACKM P") 'CLK LOW
Call RunMnemonicCommand("I2C CH2 S 7E ACKS 40 ACKM P") 'CLK HIGH
Call RunMnemonicCommand("I2C CH2 S 7E ACKS 00 ACKM P") 'CLK LOW

End Sub
Public Sub Test_Board_Meas_Switch(ConnectString)
'
'  This is for the test (calibration) board only
'  Connects Bannana (hp34401) to ADS1 and ADS2
'
Select Case ConnectString
Case "C_Vdut"
    Call ADS_MUX1("", "GND")
    Call Set_U10_U11_Test_Bits(&H0, &H2)
Case "C_Vcc"
    Call ADS_MUX1("", "GND")
    Call Set_U10_U11_Test_Bits(&H0, &H1)
Case "C_15V"
    Call ADS_MUX1("", "GND")
    Call Set_U10_U11_Test_Bits(&H0, &H4)
Case "T_Vdut"
    Call ADS_MUX1("", "GND")
    Call Set_U10_U11_Test_Bits(&H20, &H0)
Case "T_Vcc"
    Call ADS_MUX1("", "GND")
    Call Set_U10_U11_Test_Bits(&H10, &H0)
Case "ADS1"
    'Call ADS_MUX1("", "")
    Call Set_U10_U11_Test_Bits(&HA, &H0)
Case "ADS2"
    'Call ADS_MUX1("", "")
    Call Set_U10_U11_Test_Bits(&H5, &H0)
Case ""
    Call ADS_MUX1("", "")
    Call Set_U10_U11_Test_Bits(&H0, &H0)
Case Else
    Call ADS_MUX1("", "")
    Call Set_U10_U11_Test_Bits(&H0, &H0)
    MsgBox "bad test_board_meas_switch"
End Select
End Sub
