Attribute VB_Name = "auto_cal_308"
Public Vo_max_target, Vo_min_target As Double
Public v_off_emulator, v_full_emulator As Double
Public vin_offset_meas, vin_full_meas As Double
Public GD1, GO1, GI1, ZC1, ZD1 As Double
Public VIN1_full_scale As Double
Public CommPorts(8) As String
Public PortNumber As Double
Public Parity, Bitrate, Numb_Data_Bits, Numb_Stop_Bits As String
Public Flow_Control As Integer
Public Measurement_Instrument As Integer
Public PreCal_Default As String
Public PostCal_Default As String
Public Calibration_Error As Boolean


Public Function strip_file_name_from_path(path_w_file_name)
i_ck = Len(path_w_file_name)
While check_slash <> "\"
    i_ck = i_ck - 1
    check_slash = Mid$(path_w_file_name, i_ck, 1)
    If check_slash = "\" Then
    strip_file_name_from_path = Right(path_w_file_name, Len(path_w_file_name) - i_ck)
    End If
Wend

End Function

Public Function find_input_voltage()
Dim Vi_max(10) As Double
Dim gi_at_vi_max(10) As Double

    '
    'CoarseOffset to zero
    '
    ZC1 = Array_CoarseOffset(0)
    frmMain_PGA308.cmbCoarseOffset.ListIndex = 0

    '
    ' front_end_gain to back to 8, was 16 (was 8)
    '
     'FEG_INDEX = frmMain_PGA308.cmb_GainRg.ListIndex
    GI1 = Array_Front_End_Gain(0)
    frmMain_PGA308.cmbFrontEndGain.ListIndex = 0
    '
    'output gain to 2.4 (was 2)
    '
    GO1 = ArrayOutputGain(1)
    frmMain_PGA308.cmbOutputGain.ListIndex = 1
    '
    'fine gain to mid 0.744
    '
    'was GD1 = (1 + 0.33333) / 2
    GD1 = 0.868
    frmMain_PGA308.txtFineGain.Text = GD1

    '
    'txtFineOffset to mid
    '
    ' was ZD1 = 1.875
    ZD1 = 1.2
     frmMain_PGA308.txtFineOffset.Text = ZD1

Call Read_Controls

If OneWire_to_Vout = True Then
    Call one_to_Vout_write
Else
    Call Write_All_Reg
End If
Call pause(1)

'Current_Output = True
'If frmMain_PGA308.optCurrentOut = True Then
If Current_Output = True Then
    IO1 = read_output 'EuroFormat(Read_ADS1100_1(ads_Conf), "#.####")
    VO1 = Ixtr_to_Vo(IO1)
Else
    VO1 = read_output 'EuroFormat(Read_ADS1100_1(ads_Conf), "#.####")
End If

find_input_voltage1 = (VO1 - GD1 * GO1 * ZC1 * GI1 - GD1 * GO1 * ZD1) / (GI1 * GD1 * GO1)


For i_g = 1 To 5
    gi_at_vi_max(i_g) = Array_Front_End_Gain(i_g)
    GI1 = Array_Front_End_Gain(i_g)
    Vi_max(i_g) = Abs((Vsa - 0.15 - GD1 * GO1 * ZC1 * GI1 - GD1 * GO1 * ZD1) / (GI1 * GD1 * GO1))
Next i_g


new_gain = 4
new_gain_index = 0
For i_g = 1 To 5
    If Abs(find_input_voltage1) < Vi_max(i_g) Then
    new_gain = gi_at_vi_max(i_g)
    new_gain_index = i_g
    End If
Next i_g

    '
    ' front_end_gain to back to 8, was 16 (was 8)
    '
If new_gain > 4 Then
        GI1 = Array_Front_End_Gain(new_gain_index)
        frmMain_PGA308.cmbFrontEndGain.ListIndex = new_gain_index
    
    Call Read_Controls
    
    If OneWire_to_Vout = True Then
        Call one_to_Vout_write
    Else
        Call Write_All_Reg
    End If
    Call pause(1)
    
    'Current_Output = True
    'If frmMain_PGA308.optCurrentOut = True Then
    If Current_Output = True Then
        IO1 = read_output 'EuroFormat(Read_ADS1100_1(ads_Conf), "#.####")
        VO1 = Ixtr_to_Vo(IO1)
    Else
        VO1 = read_output 'EuroFormat(Read_ADS1100_1(ads_Conf), "#.####")
    End If
    
    find_input_voltage = (VO1 - GD1 * GO1 * ZC1 * GI1 - GD1 * GO1 * ZD1) / (GI1 * GD1 * GO1)

Else
    find_input_voltage = find_input_voltage1
End If

End Function


Public Sub DoFirstCalibration()


'compute gain
Gain_total = (Vo_max_target - Vo_min_target) / (vin_full_meas - vin_offset_meas)



'find gain partitioning, i.e. input gain, and output output gain
Min_Error_Target = 9999
For OG_I = 0 To 6
    For FEG_I = 0 To 31
         CheckGain = Array_Front_End_Gain(FEG_I) * ArrayOutputGain(OG_I) * 0.6667
         Error_Target = Abs(CheckGain - Gain_total)
    If Error_Target < Min_Error_Target Then
        Min_Error_Target = Error_Target
        Save_FEG = FEG_I
        Save_OG = OG_I
    End If
    Next FEG_I
Next OG_I


'copy input gain, and output gain to variables
GO1 = ArrayOutputGain(Save_OG)
GI1 = Array_Front_End_Gain(Save_FEG)


' compute Gain Dac
GD1 = Gain_total / (GO1 * GI1)

    
    
' find coarse offset
MIN_Error_coarse_offset = 999
save_CO_I = 999
For CO_I = 0 To &HFF&
        error_coarse_offset = -Array_CoarseOffset(CO_I) - vin_offset_meas 'i am not sure????
     If Abs(MIN_Error_coarse_offset) > Abs(error_coarse_offset) Then
        MIN_Error_coarse_offset = error_coarse_offset
        save_CO_I = CO_I
     End If
Next CO_I


'copy coarse offset to variables
ZC1 = Array_CoarseOffset(save_CO_I)
    

VO1 = Vo_min_target
VIN1 = vin_offset_meas
    
    
'compute Zero DAC
ZD1 = (VO1 - GI1 * GD1 * GO1 * VIN1 - GI1 * GD1 * GO1 * ZC1) / (GD1 * GO1)
    
'Copy all gains and offsets to block diagram

frmMain_PGA308.cmbCoarseOffset.ListIndex = save_CO_I
frmMain_PGA308.txtFineGain.Text = GD1
frmMain_PGA308.cmbFrontEndGain.ListIndex = Save_FEG
frmMain_PGA308.cmbOutputGain.ListIndex = Save_OG
frmMain_PGA308.txtFineOffset.Text = ZD1

'read gains and offsets from block diagram and write them to the PGA308
Call Read_Controls
If OneWire_to_Vout = True Then
    Call one_to_Vout_write
Else
    Call Write_All_Reg
End If

'Wait for ADS1100 conversion to complete and read output voltage/current
Call pause(1)

'If frmMain_PGA308.optCurrentOut = True Then
If Current_Output = True Then
    Iout_max = read_output
    'frmMain_PGA308.txtMeas_Vout_max = EuroFormat(Iout_max, "#.####")
    frmMain_PGA308.txtMeas_Vout_max = DisplayEngineering(Iout_max)
    vout_max = Ixtr_to_Vo(Iout_max)
Else
    vout_max = read_output
    frmMain_PGA308.txtMeas_Vout_max = EuroFormat(vout_max, "#.####")
End If


' compute input voltage with new gain setting.
' Note the "input voltage" has PGA308 gain and offset error imbedded in it.
VIN1 = (vout_max - GD1 * GO1 * ZC1 * GI1 - GD1 * GO1 * ZD1) / (GI1 * GD1 * GO1)
' adjust zero dac to shift output to the correct level
ZD1 = (Vo_max_target - GI1 * GD1 * GO1 * VIN1 - GI1 * GD1 * GO1 * ZC1) / (GD1 * GO1)



frmMain_PGA308.txtFineOffset.Text = ZD1

Call Read_Controls

If OneWire_to_Vout = True Then
    Call one_to_Vout_write
Else
    Call Write_All_Reg
End If

'Wait for ADS1100 conversion to complete and read output voltage/current
Call pause(1)

'If frmMain_PGA308.optCurrentOut = True Then
'Current_Output = True
If Current_Output = True Then
    Io_max_adj = read_output
    'frmMain_PGA308.txtMeas_Vout_max = EuroFormat(Io_max_adj, "#.####")
    frmMain_PGA308.txtMeas_Vout_max = DisplayEngineering(Io_max_adj)
    vo_max_adj = Ixtr_to_Vo(Io_max_adj)
Else
    vo_max_adj = read_output
    frmMain_PGA308.txtMeas_Vout_max = EuroFormat(vo_max_adj, "#.####")
End If



VIN1_full_scale = (vo_max_adj - GD1 * GO1 * ZC1 * GI1 - GD1 * GO1 * ZD1) / (GI1 * GD1 * GO1)
'frmMain_PGA308.txtMeas_Full_Scale = EuroFormat(VIN1_full_scale, "#.####")
frmMain_PGA308.txtMeas_Full_Scale = DisplayEngineering(VIN1_full_scale)




End Sub
Public Function read_output()

'If frmMain_PGA308.optCurrentOut = True Then
If Current_Output = True Then
    If frmMain_PGA308.optExtMeter = True Then
        read_output = EngineeringVal(InputBox("Enter reading from DVM"))
    ElseIf frmMain_PGA308.OptUSB_DAQ_AtoD = True Then
        Call Current_Voltage_Mode(1)
        Call pause(1)
        frmMain_PGA308.ProgressBar1.value = 20
    
        read_output = Read_I_Loop(ads_Conf)
        Call Current_Voltage_Mode(0)
        Call pause(1)
    Else
        If frmMain_PGA308.cmbOutputMode.Text = "Vout to One" Then
            Call pause(1.5)
        End If
        SerPut "MEAS:CURR:DC? 50E-3,0.1E-6"
        SerGetNum read_output
    End If
    'txtMeasVout_min = txtIout
    
'ElseIf frmMain_PGA308.optCurrentOut = False Then
 ElseIf Current_Output = False Then

    If frmMain_PGA308.optExtMeter = True Then
        read_output = EngineeringVal(InputBox("Enter reading from DVM"))
    ElseIf frmMain_PGA308.OptUSB_DAQ_AtoD = True Then
        Call pause(1#)
        read_output = Read_ADS1100_1(ads_Conf)
    Else
        If frmMain_PGA308.cmbOutputMode.Text = "Vout to One" Then
            Call pause(1.5)
        End If
        SerPut "MEAS:VOLT:DC? 10,0.00001"
        SerGetNum read_output
    End If

    'frmMain_PGA308.ProgressBar1.value = 20

    
    'txtMeasVout_min = txtVout
End If

End Function
