Attribute VB_Name = "auto_cal_308"
Public Vo_max_target, Vo_min_target As Double
Public v_off_emulator, v_full_emulator As Double
Public vin_offset_meas, vin_full_meas As Double
Public GD1, GO1, GI1, ZC1, ZD1 As Double
Public VIN1_full_scale As Double
Public Function find_input_voltage()
    '
    'CoarseOffset to zero
    '
    ZC1 = Array_CoarseOffset(0)
    frmMain_PGA308.cmbCoarseOffset.ListIndex = 0

    '
    ' front_end_gain to 16 (was 8)
    '
    GI1 = Array_Front_End_Gain(4)
    frmMain_PGA308.cmbFrontEndGain.ListIndex = 4
    '
    'output gain to 2
    '
    GO1 = ArrayOutputGain(0)
    frmMain_PGA308.cmbOutputGain.ListIndex = 0
    '
    'fine gain to mid
    '
    GD1 = (1 + 0.33333) / 2
    frmMain_PGA308.txtFineGain.Text = GD1

    '
    'txtFineOffset to mid
    '
    ZD1 = 1.875
     frmMain_PGA308.txtFineOffset.Text = ZD1

Call Read_Controls

If OneWire_to_Vout = True Then
    Call one_to_Vout_write
Else
    Call Write_All_Reg
End If
Call pause(1)

'Current_Output = True
'If frmMain_PGA308.optCurrentOut = True Then
If Current_Output = True Then
    IO1 = read_output 'EuroFormat(Read_ADS1100_1(ads_Conf), "#.####")
    VO1 = Ixtr_to_Vo(IO1)
Else
    VO1 = read_output 'EuroFormat(Read_ADS1100_1(ads_Conf), "#.####")
End If

find_input_voltage = (VO1 - GD1 * GO1 * ZC1 * GI1 - GD1 * GO1 * ZD1) / (GI1 * GD1 * GO1)
End Function

Public Sub DoFirstCalibration()


'compute gain
Gain_total = (Vo_max_target - Vo_min_target) / (vin_full_meas - vin_offset_meas)



'find gain partitioning, i.e. input gain, and output output gain
Min_Error_Target = 9999
For OG_I = 0 To 6
    For FEG_I = 0 To 31
         CheckGain = Array_Front_End_Gain(FEG_I) * ArrayOutputGain(OG_I) * 0.6667
         Error_Target = Abs(CheckGain - Gain_total)
    If Error_Target < Min_Error_Target Then
        Min_Error_Target = Error_Target
        Save_FEG = FEG_I
        Save_OG = OG_I
    End If
    Next FEG_I
Next OG_I


'copy input gain, and output gain to variables
GO1 = ArrayOutputGain(Save_OG)
GI1 = Array_Front_End_Gain(Save_FEG)


' compute Gain Dac
GD1 = Gain_total / (GO1 * GI1)

    
    
' find coarse offset
MIN_Error_coarse_offset = 999
save_CO_I = 999
For CO_I = 0 To &HFF&
        error_coarse_offset = -Array_CoarseOffset(CO_I) - vin_offset_meas 'i am not sure????
     If Abs(MIN_Error_coarse_offset) > Abs(error_coarse_offset) Then
        MIN_Error_coarse_offset = error_coarse_offset
        save_CO_I = CO_I
     End If
Next CO_I


'copy coarse offset to variables
ZC1 = Array_CoarseOffset(save_CO_I)
    

VO1 = Vo_min_target
VIN1 = vin_offset_meas
    
    
'compute Zero DAC
ZD1 = (VO1 - GI1 * GD1 * GO1 * VIN1 - GI1 * GD1 * GO1 * ZC1) / (GD1 * GO1)
    
'Copy all gains and offsets to block diagram
frmMain_PGA308.cmbCoarseOffset.ListIndex = save_CO_I
frmMain_PGA308.txtFineGain.Text = GD1
frmMain_PGA308.cmbFrontEndGain.ListIndex = Save_FEG
frmMain_PGA308.cmbOutputGain.ListIndex = Save_OG
frmMain_PGA308.txtFineOffset.Text = ZD1

'read gains and offsets from block diagram and write them to the PGA308
Call Read_Controls
If OneWire_to_Vout = True Then
    Call one_to_Vout_write
Else
    Call Write_All_Reg
End If

'Wait for ADS1100 conversion to complete and read output voltage/current
Call pause(1)

'If frmMain_PGA308.optCurrentOut = True Then
If Current_Output = True Then
    Iout_max = read_output
    'frmMain_PGA308.txtMeas_Vout_max = EuroFormat(Iout_max, "#.####")
    frmMain_PGA308.txtMeas_Vout_max = DisplayEngineering(Iout_max)
    vout_max = Ixtr_to_Vo(Iout_max)
Else
    vout_max = read_output
    frmMain_PGA308.txtMeas_Vout_max = EuroFormat(vout_max, "#.####")
End If


' compute input voltage with new gain setting.
' Note the "input voltage" has PGA308 gain and offset error imbedded in it.
VIN1 = (vout_max - GD1 * GO1 * ZC1 * GI1 - GD1 * GO1 * ZD1) / (GI1 * GD1 * GO1)
' adjust zero dac to shift output to the correct level
ZD1 = (Vo_max_target - GI1 * GD1 * GO1 * VIN1 - GI1 * GD1 * GO1 * ZC1) / (GD1 * GO1)



frmMain_PGA308.txtFineOffset.Text = ZD1

Call Read_Controls

If OneWire_to_Vout = True Then
    Call one_to_Vout_write
Else
    Call Write_All_Reg
End If

'Wait for ADS1100 conversion to complete and read output voltage/current
Call pause(1)

'If frmMain_PGA308.optCurrentOut = True Then
'Current_Output = True
If Current_Output = True Then
    Io_max_adj = read_output
    'frmMain_PGA308.txtMeas_Vout_max = EuroFormat(Io_max_adj, "#.####")
    frmMain_PGA308.txtMeas_Vout_max = DisplayEngineering(Io_max_adj)
    vo_max_adj = Ixtr_to_Vo(Io_max_adj)
Else
    vo_max_adj = read_output
    frmMain_PGA308.txtMeas_Vout_max = EuroFormat(vo_max_adj, "#.####")
End If



VIN1_full_scale = (vo_max_adj - GD1 * GO1 * ZC1 * GI1 - GD1 * GO1 * ZD1) / (GI1 * GD1 * GO1)
'frmMain_PGA308.txtMeas_Full_Scale = EuroFormat(VIN1_full_scale, "#.####")
frmMain_PGA308.txtMeas_Full_Scale = DisplayEngineering(VIN1_full_scale)




End Sub
Public Function read_output()

'If frmMain_PGA308.optCurrentOut = True Then
If Current_Output = True Then
    If frmMain_PGA308.optExtMeter = True Then
        read_output = EngineeringVal(InputBox("Enter reading from DVM"))
    Else
        Call Current_Voltage_Mode(1)
        Call pause(1)
        frmMain_PGA308.ProgressBar1.value = 20
    
        read_output = Read_I_Loop(ads_Conf)
        Call Current_Voltage_Mode(0)
        Call pause(1)
    End If
    'txtMeasVout_min = txtIout
    
'ElseIf frmMain_PGA308.optCurrentOut = False Then
 ElseIf Current_Output = False Then

    If frmMain_PGA308.optExtMeter = True Then
        read_output = EngineeringVal(InputBox("Enter reading from DVM"))
    Else
        Call pause(1#)
        read_output = Read_ADS1100_1(ads_Conf)
    End If

    'frmMain_PGA308.ProgressBar1.value = 20

    
    'txtMeasVout_min = txtVout
End If

End Function
