Attribute VB_Name = "GeneralSerialPortRoutines"
Option Explicit
Public CommTrue(16) As Boolean
Public PortNumber As Integer
Public BitRate As Long
Dim NumberOfPorts As Integer
'General routines used by applications that access the serial port.
'Some routines access forms and variables in template.vbp.

'The following constants are from win32api.txt:
'Constants used in DCB access
'Parity
Global Const NOPARITY = 0
Global Const ODDPARITY = 1
Global Const EVENPARITY = 2
Global Const MARKPARITY = 3
Global Const SPACEPARITY = 4
'Stop bits
Global Const ONESTOPBIT = 0
Global Const ONE5STOPBITS = 1
Global Const TWOSTOPBITS = 2

'Errors
Global Const CE_RXOVER = &H1
Global Const CE_OVERRUN = &H2
Global Const CE_RXPARITY = &H4
Global Const CE_FRAME = &H8
Global Const CE_BREAK = &H10
Global Const CE_CTSTO = &H20
Global Const CE_DSRTO = &H40
Global Const CE_RLSDTO = &H80
Global Const CE_TXFULL = &H100
Global Const CE_PTO = &H200
Global Const CE_IOE = &H400
Global Const CE_DNS = &H800
Global Const CE_OOP = &H1000
Global Const CE_MODE = &H8000

Global Const IE_BADID = (-1)
Global Const IE_OPEN = (-2)
Global Const IE_NOPEN = (-3)
Global Const IE_MEMORY = (-4)
Global Const IE_DEFAULT = (-5)
Global Const IE_HARDWARE = (-10)
Global Const IE_BYTESIZE = (-11)
Global Const IE_BAUDRATE = (-12)

'CommEventMask bits
Global Const EV_RXCHAR = &H1
Global Const EV_RXFLAG = &H2
Global Const EV_TXEMPTY = &H4
Global Const EV_CTS = &H8
Global Const EV_DSR = &H10
Global Const EV_RLSD = &H20
Global Const EV_BREAK = &H40
Global Const EV_ERR = &H80
Global Const EV_RING = &H100
Global Const EV_PERR = &H200
Global Const EV_CTSS = &H400
Global Const EV_DSRS = &H800
Global Const EV_RLSDS = &H1000

'EscapeCommFunction values
Global Const SETXOFF = 1
Global Const SETXON = 2
Global Const SETRTS = 3
Global Const CLRRTS = 4
Global Const SETDTR = 5
Global Const CLRDTR = 6
Global Const RESETDEV = 7
Global Const GETMAXLPT = 8
Global Const GETMAXCOM = 9
Global Const GETBASEIRQ = 10

'Bit rates
Global Const CBR_110 = &HFF10
Global Const CBR_300 = &HFF11
Global Const CBR_600 = &HFF12
Global Const CBR_1200 = &HFF13
Global Const CBR_2400 = &HFF14
Global Const CBR_4800 = &HFF15
Global Const CBR_9600 = &HFF16
Global Const CBR_14400 = &HFF17
Global Const CBR_19200 = &HFF18
Global Const CBR_38400 = &HFF1B
Global Const CBR_56000 = &HFF1F
Global Const CBR_128000 = &HFF23
Global Const CBR_256000 = &HFF27

Global Const CN_RECEIVE = &H1
Global Const CN_TRANSMIT = &H2
Global Const CN_EVENT = &H4
Global Const CSTF_CTSHOLD = &H1
Global Const CSTF_DSRHOLD = &H2
Global Const CSTF_RLSDHOLD = &H4
Global Const CSTF_XOFFHOLD = &H8
Global Const CSTF_XOFFSENT = &H10
Global Const CSTF_EOF = &H20
Global Const CSTF_TXIM = &H40
Global Const LPTx = &H80

Public Const OPEN_EXISTING = 3

'  DTR Control Flow Values.
Public Const DTR_CONTROL_DISABLE = &H0
Public Const DTR_CONTROL_ENABLE = &H1
Public Const DTR_CONTROL_HANDSHAKE = &H2

'  RTS Control Flow Values
Public Const RTS_CONTROL_DISABLE = &H0
Public Const RTS_CONTROL_ENABLE = &H1
Public Const RTS_CONTROL_HANDSHAKE = &H2
Public Const RTS_CONTROL_TOGGLE = &H3

Public Const GENERIC_READ = &H80000000
Public Const GENERIC_WRITE = &H40000000

'DCB Bits values:
Public Const FLAG_fBinary& = &H1
Public Const FLAG_fParity& = &H2
Public Const FLAG_fOutxCtsFlow = &H4
Public Const FLAG_fOutxDsrFlow = &H8
Public Const FLAG_fDtrControl = &H30
Public Const FLAG_fDsrSensitivity = &H40
Public Const FLAG_fTXContinueOnXoff = &H80
Public Const FLAG_fOutX = &H100
Public Const FLAG_fInX = &H200
Public Const FLAG_fErrorChar = &H400
Public Const FLAG_fNull = &H800
Public Const FLAG_fRtsControl = &H3000
Public Const FLAG_fAbortOnError = &H4000

'End of win32api.txt constants.

Public Type COMMTIMEOUTS
     ReadIntervalTimeout As Long
    ReadTotalTimoutMultiplier As Long
    ReadTotalTimeoutConstant As Long
    WriteTotalTimeoutMultiplier As Long
    WriteTotalTimeoutConstant As Long
End Type

Public Type dcbType
        DCBlength As Long
        BaudRate As Long
        Bits1 As Long
        wReserved As Integer
        XonLim As Integer
        XoffLim As Integer
        ByteSize As Byte
        Parity As Byte
        StopBits As Byte
        XonChar As Byte
        XoffChar As Byte
        ErrorChar As Byte
        EofChar As Byte
        EvtChar As Byte
        wReserved2 As Integer
End Type

'Global variables & constants used by the application:

Public Const ProjectName = "PGA309Bench"

Public Buffer As Variant
Public CommDCB As dcbType
Public CommPorts() As String
Public OneByteDelay As Single
Public PortExists As Boolean
Public PortInUse As Boolean
' Public PortNumber As Integer
Public PortOpen As Boolean
Public SaveDataInFile As Boolean
Public TimedOut As Boolean

'API declares:
Public Declare Function apiGetCommState _
    Lib "kernel32" _
    Alias "GetCommState" _
    (ByVal nCid As Long, _
    lpDCB As dcbType) _
    As Long
Public Declare Function apiSetCommState _
    Lib "kernel32" _
    Alias "SetCommState" _
    (ByVal hCommDev As Long, _
    lpDCB As dcbType) _
    As Long
Public Declare Function EscapeCommFunction _
    Lib "kernel32" _
    (ByVal nCid As Long, _
    ByVal nFunc As Long) _
    As Long
Public Declare Function GetCommTimeouts _
    Lib "kernel32" _
    (ByVal hFile As Long, _
    lpCommTimeouts As COMMTIMEOUTS) _
    As Long
Public Declare Function SetCommTimeouts _
    Lib "kernel32" _
    (ByVal hFile As Long, _
    lpCommTimeouts As COMMTIMEOUTS) _
    As Long
Public Declare Function timeGetTime _
    Lib "winmm.dll" () _
    As Long
Public Declare Function TransmitCommChar _
    Lib "kernel32" _
    (ByVal nCid As Long, _
    ByVal cChar As Byte) _
    As Long

Public Function fncByteToAsciiHex _
    (ByteToConvert As Byte) _
    As String
'Converts a byte to a 2-character ASCII Hex string
Dim AsciiHex As String
AsciiHex = Hex$(ByteToConvert)
If Len(AsciiHex) = 1 Then
    AsciiHex = "0" & AsciiHex
End If
fncByteToAsciiHex = AsciiHex
End Function

Public Function fncDisplayDateAndTime() As String
'Date and time formatting.
fncDisplayDateAndTime = _
    CStr(Format(Date, "General Date")) & ", " & _
    (Format(Time, "Long Time"))
End Function

Public Function fncGetHighestComPortNumber() As Integer
'Returns the number of the system's highest Com port.
'Also shows how to use the EscapeCommFunction API call.
Dim ClosePortOnExit As Boolean
Dim PortCount As Long
Dim handle As Long
'The API call requires a CommID of an open port.
If frmMain_PGA308.MSComm1.PortOpen = False Then
    frmMain_PGA308.MSComm1.PortOpen = True
    ClosePortOnExit = True
Else
    ClosePortOnExit = False
End If
handle = frmMain_PGA308.MSComm1.CommID
PortCount = GETMAXCOM
'Add 1 because EscapeCommFunction begins counting at 0.
fncGetHighestComPortNumber = _
    EscapeCommFunction(handle, PortCount) + 1
If ClosePortOnExit = True Then
    frmMain_PGA308.MSComm1.PortOpen = False
End If
End Function

Public Function fncOneByteDelay(BitRate As Long) As Single
'Calculate the time in milliseconds to transmit
'8 bits + 1 Start & 1 Stop bit.
Dim DelayTime As Integer
DelayTime = 10000 / BitRate
fncOneByteDelay = DelayTime
End Function

Public Sub Delay(DelayInMilliseconds As Single)
'Delay timer with approximately 1-msec. resolution.
'Uses the API function timeGetTime.
'Rolls over 24 days after the last Windows startup.
Dim Timeout As Single
Timeout = DelayInMilliseconds + timeGetTime()
Do Until timeGetTime() >= Timeout
    DoEvents
Loop
End Sub

Public Sub FindPorts()
'Find Comm ports by trying to open each.
'Each port must support the current settings (bit rate, etc.).
Dim Count As Integer
'Dim NumberOfPorts As Integer
Dim SavedPortNumber As Integer
Dim SaveCurrentPort As Boolean
ReDim CommPorts(1 To 16)
On Error Resume Next
SaveCurrentPort = False
NumberOfPorts = 0
'If a port is already open, reopen it on exiting.
If frmMain_PGA308.MSComm1.PortOpen = True Then
        frmMain_PGA308.MSComm1.PortOpen = False
        SavedPortNumber = PortNumber
        SaveCurrentPort = True
End If
For Count = 1 To 16
    frmMain_PGA308.MSComm1.CommPort = Count
    frmMain_PGA308.MSComm1.PortOpen = True
    If Err.Number = 8005 Then
        'The port is already open
        'The port exists, so add it to the list.
        NumberOfPorts = NumberOfPorts + 1
        CommPorts(NumberOfPorts) = "COM" & CStr(Count)
        If SavedPortNumber = Count Then
            frmMain_PGA308.MSComm1.PortOpen = False
        End If
    ElseIf frmMain_PGA308.MSComm1.PortOpen = True Then
        'If the port opens, it exists.
        'Close it and add to the list.
        frmMain_PGA308.MSComm1.PortOpen = False
        NumberOfPorts = NumberOfPorts + 1
        CommPorts(NumberOfPorts) = "COM" & CStr(Count)
    End If
    Err.Clear
Next Count
'Disable the error handler
On Error GoTo 0
ReDim Preserve CommPorts(1 To NumberOfPorts)
If SaveCurrentPort = True Then
    PortNumber = SavedPortNumber
    frmMain_PGA308.MSComm1.CommPort = PortNumber
    If frmMain_PGA308.MSComm1.PortOpen = False Then
        frmMain_PGA308.MSComm1.PortOpen = True
    End If
End If
Call getOrderPorts
End Sub

Sub ImmediateTransmit(ByteToSend As Byte)
'Places a byte at the top of the transmit buffer
'for immediate sending.
Dim Success As Boolean
Success = TransmitCommChar(frmMain_PGA308.MSComm1.CommID, ByteToSend)
If Success = False Then
Success = False
End If
End Sub

Public Sub LowResDelay(DelayInMilliseconds As Single)
'Uses the system timer, with resolution of about 56 milliseconds.
Dim Timeout As Single
'Add the delay to the current time.
Timeout = Timer + DelayInMilliseconds / 1000
If Timeout > 86399 Then
    'If the end of the delay spans midnight,
    'subtract 24 hrs. from the Timeout count:
    Timeout = Timeout - 86399
    'and wait for midnight:
    Do Until Timer < 100
        DoEvents
    Loop
End If
'Wait for the Timeout count.
Do Until Timer >= Timeout
    DoEvents
Loop
End Sub

Public Sub SavePortSettings()
'Save user settings for next time.
'SaveSetting App.Title, "Startup", "BitRate", BitRate
'SaveSetting App.Title, "Startup", "SerialPort", PortNumber
'SaveSetting ProjectName, "Startup", "ParallelPort", Port_Data
'SaveSetting App.Title, "Startup", "TalkMode", TalkMode
'SaveSetting App.Title, "Startup", "PRG_Vout_Short", OW_Vout_short
'SaveSetting App.Title, "Startup", "Testpin_high", Testpin_high
'SaveSetting App.Title, "Startup", "LastMonthChecked", LastMonthChecked
'SaveSetting App.Title, "Startup", "LastYearChecked", LastYearChecked
End Sub

Public Sub SerShutDown()
'Close the port.
'If frmmain_pga308.MSComm1.PortOpen = True Then
'    frmmain_pga308.MSComm1.PortOpen = False
'End If
'Call SavePortSettings
End Sub
Function SetBaudNewRate(oldRate As String) As String
 Select Case oldRate
  Case "115200"
   SetBaudNewRate = "57600"
  Case "57600"
   SetBaudNewRate = "38400"
  Case "38400"
   SetBaudNewRate = "19200"
  Case "19200"
   SetBaudNewRate = "115200"
End Select
  
End Function
Function BaudRateCurrent(curr As String) As String
 Select Case curr
  Case "57600"
   BaudRateCurrent = "115200"
  Case "38400"
   BaudRateCurrent = "57600"
  Case "19200"
   BaudRateCurrent = "38400"
  Case "115200"
   BaudRateCurrent = "19200"
End Select
  
End Function

Private Sub getOrderPorts()
Dim J As Integer
 For J = 1 To NumberOfPorts
Select Case CommPorts(J)
Case "COM1"
 CommTrue(1) = True
Case "COM2"
 CommTrue(2) = True
Case "COM3"
 CommTrue(3) = True
Case "COM4"
 CommTrue(4) = True
Case "COM5"
 CommTrue(5) = True
Case "COM6"
 CommTrue(6) = True
Case "COM7"
 CommTrue(7) = True
Case "COM8"
 CommTrue(8) = True
Case "COM9"
 CommTrue(9) = True
Case "COM10"
 CommTrue(10) = True
Case "COM11"
 CommTrue(11) = True
Case "COM12"
 CommTrue(12) = True
Case "COM13"
 CommTrue(13) = True
Case "COM14"
 CommTrue(14) = True
Case "COM15"
 CommTrue(15) = True
Case "COM16"
 CommTrue(16) = True
 
End Select
Next J

End Sub

'Public Sub InitSerPort()
'Dim j As Integer
'bitSetRate = SetBaudNewRate("19200")
'Call GetSettings
'Call getOrderPorts
'PortNumber = 1
'Do
'If CommTrue(PortNumber) Then
'    PortOpen = frmmain_pga308.fncInitializeComPort(Int(Val(bitSetRate)), PortNumber)
'    Call VbSetCommTimeouts(Int(Val(bitSetRate)))
'End If
'If IsboardThere Then
   'Exit Do
'Else: Call ShutDown
      'PortNumber = PortNumber + 1
'End If
'DoEvents
'Loop Until PortNumber = NumberOfPorts + 1
'If IsboardThere = False Then
   'Call BoardNotFound
   'frmPortSettings.Show
'End If
'End Sub

Public Sub VbSetCommTimeouts(Rate As Long)
'The default timeout for serial-port operations is 5 seconds.
'This routine sets the timeout so that
'the requested number of bytes can transmit or be read
'at the current bit rate.
'Uses the GetCommTimeouts and SetCommTimeouts API functions.
Dim Timeouts As COMMTIMEOUTS
Dim Success As Long
Dim OneByteTimeout As Long
Success = GetCommTimeouts(frmMain_PGA308.MSComm1.CommID, Timeouts)
OneByteTimeout = CLng(fncOneByteDelay(Rate))
If frmMain_PGA308.MSComm1.PortOpen = True Then
    'All values are milliseconds
    'Maximum time between two received characters:
    Timeouts.ReadIntervalTimeout = OneByteTimeout
    'Maximum time for a character to arrive:
    Timeouts.ReadTotalTimoutMultiplier = OneByteTimeout
    'Provide enough time for the bytes to arrive + 1 second.
    Timeouts.ReadTotalTimeoutConstant = 1000
    'Maximum time for a character to transmit:
    Timeouts.WriteTotalTimeoutMultiplier = OneByteTimeout
    'Provide enough time for the bytes to transmit + 1 second.
    Timeouts.WriteTotalTimeoutConstant = 1000
    Success = SetCommTimeouts(frmMain_PGA308.MSComm1.CommID, Timeouts)
End If
'For debugging/verifying:
'Success = GetCommTimeouts(frmmain_pga308.MSComm1.CommID, Timeouts)
'Debug.Print Timeouts.ReadIntervalTimeout
'Debug.Print Timeouts.ReadTotalTimoutMultiplier
'Debug.Print Timeouts.ReadTotalTimeoutConstant
'Debug.Print Timeouts.WriteTotalTimeoutMultiplier
'Debug.Print Timeouts.WriteTotalTimeoutConstant
End Sub
